package envoy.client;

import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.time.Instant;

import javax.ws.rs.client.Client;
import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.client.Entity;
import javax.ws.rs.client.WebTarget;
import javax.ws.rs.core.Response;
import javax.xml.bind.JAXBException;
import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;

import envoy.client.ui.ChatWindow;
import envoy.schema.Message;
import envoy.schema.ObjectFactory;

/**
 * Project: <strong>envoy-client</strong><br>
 * File: <strong>EnvoyClient.java</strong><br>
 * Created: <strong>28 Sep 2019</strong><br>
 * Author: <strong>Kai S. K. Engelbart and Maximilian K&aumlfer</strong>
 */

public class EnvoyClient {

	public static String content1 = "";
	
	
	/**
	 * Calls Class ChatWidow
	 */
	public static void main(String[] args) throws DatatypeConfigurationException, JAXBException {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					ChatWindow frame = new ChatWindow();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}
	
	/**
	 * specifies data <br>
	 * sends xml to server <br>
	 * gets response from server (currently 204)
	 */
	public static void sendMessage() throws DatatypeConfigurationException, JAXBException {
		
		ObjectFactory factory = new ObjectFactory();
		
		Message.MetaData metaData = factory.createMessageMetaData();
		metaData.setSender("Kai");
		metaData.setRecipient("Maxi");
		metaData.setState(false);
		metaData.setDate(DatatypeFactory.newInstance().newXMLGregorianCalendar(Instant.now().toString()));

		Message.Content content = factory.createMessageContent();
		content.setType("text");
		content.setText(content1);

		Message message = factory.createMessage();
		message.setMetaData(metaData);
		message.getContent().add(content);

		Client		client		= ClientBuilder.newClient();
		WebTarget	target		= client.target("http://localhost:8080/envoy-server/rest/message/send");
		Response	response	= target.request().post(Entity.entity(message, "application/xml"));
		System.out.println("Response code: " + response.getStatus());
		response.close();
		
		
		
	}
	
	/**
	 * sets content of xml to content from ChatWindow
	 */
	public void setContent (String content2) {
		content1 = content2;
	}
	
}
